#!/bin/bash
(
  flock -n -x 200 || exit 1

  LOCALDIR='{{ storage_mountpoint }}'
  PROVIDER='{{ provider }}:'
  RCLONE_BIN='/usr/local/bin/rclone'
  RCLONE_CMD_SYNC="$RCLONE_BIN sync -v"

  function remove_https_from_wasabi_url()
  {
    find "/${LOCALDIR}/${bucket}/" -name descriptor.json \
      -exec sed -i 's,https://s3.eu-central-1.wasabisys.com,http://s3.eu-central-1.wasabisys.com,g' '{}' \;
  }

  function make_bucket_world_readable()
  {
    find "${LOCALDIR}/${bucket}" -type f -not -perm /o=r -exec chmod a+r {} +
  }

  function logthis()
  {
    ts="$( date '+%Y/%m/%d %H:%M:%S' )"
    >&2 echo "${ts} $*"
  }

  if [ ! -d "$LOCALDIR" ] ; then
    logthis "FATAL : LOCALDIR=$LOCALDIR does not exist."
    exit 2
  fi

  # whatever happens with the rclone stuff, let's cleanup old stuff
  for i in omeka 24hinanewsroom bibliotecamovil maguare osm static-sites ; do
    [ -d "${LOCALDIR}/olip-packages-prod/$i" ] && {
      logthis "FAKE  : remove old ideascube-the-software packages (${i})..."
      echo rm -rf "${LOCALDIR}/olip-packages-prod/$i"
    }
  done

  if [ ! -x "$RCLONE_BIN" ]; then
    logthis "FATAL : $RCLONE_BIN not executable."
    exit 1
  fi

  logthis "rclone version:"
  "$RCLONE_BIN" version


  "$RCLONE_BIN" listremotes | grep -q "$PROVIDER" || {
    logthis "FATAL : PROVIDER=$PROVIDER does not exist. Available remotes:"
    "$RCLONE_BIN" listremotes
    exit 1
  }

  available_buckets=$( "$RCLONE_BIN" lsf "$PROVIDER" | sed -E '/preprod|ideascube-catalog|maestro-contents/d;' )

  for bucket in $available_buckets ; do

    logthis "INFO  : Sync bucket ${bucket}..."

    if [ "$bucket" == "olip-packages-prod/" ]; then
      logthis "INFO  : $RCLONE_CMD_SYNC --include hugo/** --include zim/** --include moodle/** ${PROVIDER}${bucket} ${LOCALDIR}/${bucket}"
      $RCLONE_CMD_SYNC --include "hugo/**" --include "zim/**" --include "moodle/**" "${PROVIDER}${bucket}" "${LOCALDIR}/${bucket}"
    else
      logthis "INFO  : $RCLONE_CMD_SYNC ${PROVIDER}${bucket} ${LOCALDIR}/${bucket}"
      $RCLONE_CMD_SYNC "${PROVIDER}${bucket}" "${LOCALDIR}/${bucket}"
    fi

    if [ ! $? -eq 0 ]; then
      logthis "ERROR : Sync bucket ${bucket} failed."
    else
      logthis "INFO  : Sync bucket ${bucket} successful ..."
    fi

    [ "$bucket" == "olip-catalog-descriptor/" ] && {
      logthis "INFO  : Remove SSL from catalog URLs..."
      remove_https_from_wasabi_url
    }

    logthis "INFO  : Ensure files are world readable..."
    make_bucket_world_readable
    
  done

) 200>/var/lock/.rclone.exclusivelock
